FTPTaskMirrorImpl (Apache Ant API)
Date: 2013-12-23

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.tools.ant.taskdefs.optional.net
Class FTPTaskMirrorImpl

    java.lang.Object
      org.apache.tools.ant.taskdefs.optional.net.FTPTaskMirrorImpl

All Implemented Interfaces:
  FTPTaskMirror

    public class FTPTaskMirrorImpl

extends java.lang.Object
implements FTPTaskMirror

Nested Class Summary
`protected class` | `FTPTaskMirrorImpl.FTPDirectoryScanner` internal class allowing to read the contents of a remote file system using the FTP protocol used in particular for ftp get operations differences with DirectoryScanner "" (the root of the fileset) is never included in the included directories followSymlinks defaults to false
`protected static class` | `FTPTaskMirrorImpl.FTPFileProxy` internal class providing a File-like interface to some of the information available from the FTP server

Constructor Summary
`FTPTaskMirrorImpl(FTPTask task)` Constructor.

Method Summary
`protected void` | `createParents(org.apache.commons.net.ftp.FTPClient ftp, java.lang.String filename)` Creates all parent directories specified in a complete relative pathname.
`protected void` | `delFile(org.apache.commons.net.ftp.FTPClient ftp, java.lang.String filename)` Delete a file from the remote host.
`void` | `doFTP()`
`protected void` | `doSiteCommand(org.apache.commons.net.ftp.FTPClient ftp, java.lang.String theCMD)` Sends a site command to the ftp server
`protected void` | `executeRetryable(RetryHandler h, Retryable r, java.lang.String descr)` Executable a retryable object.
`protected void` | `getFile(org.apache.commons.net.ftp.FTPClient ftp, java.lang.String dir, java.lang.String filename)` Retrieve a single file from the remote host.
`protected boolean` | `isUpToDate(org.apache.commons.net.ftp.FTPClient ftp, java.io.File localFile, java.lang.String remoteFile)` Checks to see if the remote file is current as compared with the local file.
`protected void` | `listFile(org.apache.commons.net.ftp.FTPClient ftp, java.io.BufferedWriter bw, java.lang.String filename)` List information about a single file from the remote host.
`protected void` | `makeRemoteDir(org.apache.commons.net.ftp.FTPClient ftp, java.lang.String dir)` Create the specified directory on the remote host.
`protected java.lang.String` | `resolveFile(java.lang.String file)` Correct a file path to correspond to the remote host requirements.
`protected void` | `rmDir(org.apache.commons.net.ftp.FTPClient ftp, java.lang.String dirname)` Delete a directory, if empty, from the remote host.
`protected void` | `sendFile(org.apache.commons.net.ftp.FTPClient ftp, java.lang.String dir, java.lang.String filename)` Sends a single file to the remote host.
`protected void` | `transferFiles(org.apache.commons.net.ftp.FTPClient ftp)` Sends all files specified by the configured filesets to the remote server.
`protected int` | `transferFiles(org.apache.commons.net.ftp.FTPClient ftp, FileSet fs)` For each file in the fileset, do the appropriate action: send, get, delete, or list.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### FTPTaskMirrorImpl

    public FTPTaskMirrorImpl(FTPTask task)

  Constructor.

  Parameters:
    `task` - the FTPTask that uses this mirror.

Method Detail

### executeRetryable

    protected void executeRetryable(RetryHandler h,
                                    Retryable r,
                                    java.lang.String descr)
                             throws java.io.IOException

  Executable a retryable object.

  Parameters:
    `h` - the retry handler.
    `r` - the object that should be retried until it succeeds or the number of retrys is reached.
    `descr` - a description of the command that is being run.
  Throws:
    `java.io.IOException` - if there is a problem.

### transferFiles

    protected int transferFiles(org.apache.commons.net.ftp.FTPClient ftp,
                                FileSet fs)
                         throws java.io.IOException,
                                BuildException

  For each file in the fileset, do the appropriate action: send, get, delete, or list.

  Parameters:
    `ftp` - the FTPClient instance used to perform FTP actions
    `fs` - the fileset on which the actions are performed.
  Returns:
    the number of files to be transferred.
  Throws:
    `java.io.IOException` - if there is a problem reading a file
    `BuildException` - if there is a problem in the configuration.

### transferFiles

    protected void transferFiles(org.apache.commons.net.ftp.FTPClient ftp)
                          throws java.io.IOException,
                                 BuildException

  Sends all files specified by the configured filesets to the remote server.

  Parameters:
    `ftp` - the FTPClient instance used to perform FTP actions
  Throws:
    `java.io.IOException` - if there is a problem reading a file
    `BuildException` - if there is a problem in the configuration.

### resolveFile

    protected java.lang.String resolveFile(java.lang.String file)

  Correct a file path to correspond to the remote host requirements. This implementation currently assumes that the remote end can handle Unix-style paths with forward-slash separators. This can be overridden with the `separator` task parameter. No attempt is made to determine what syntax is appropriate for the remote host.

  Parameters:
    `file` - the remote file name to be resolved
  Returns:
    the filename as it will appear on the server.

### createParents

    protected void createParents(org.apache.commons.net.ftp.FTPClient ftp,
                                 java.lang.String filename)
                          throws java.io.IOException,
                                 BuildException

  Creates all parent directories specified in a complete relative pathname. Attempts to create existing directories will not cause errors.

  Parameters:
    `ftp` - the FTP client instance to use to execute FTP actions on the remote server.
    `filename` - the name of the file whose parents should be created.
  Throws:
    `java.io.IOException` - under non documented circumstances
    `BuildException` - if it is impossible to cd to a remote directory

### isUpToDate

    protected boolean isUpToDate(org.apache.commons.net.ftp.FTPClient ftp,
                                 java.io.File localFile,
                                 java.lang.String remoteFile)
                          throws java.io.IOException,
                                 BuildException

  Checks to see if the remote file is current as compared with the local file. Returns true if the target file is up to date.

  Parameters:
    `ftp` - ftpclient
    `localFile` - local file
    `remoteFile` - remote file
  Returns:
    true if the target file is up to date
  Throws:
    `java.io.IOException` - in unknown circumstances
    `BuildException` - if the date of the remote files cannot be found and the action is GET_FILES

### doSiteCommand

    protected void doSiteCommand(org.apache.commons.net.ftp.FTPClient ftp,
                                 java.lang.String theCMD)
                          throws java.io.IOException,
                                 BuildException

  Sends a site command to the ftp server

  Parameters:
    `ftp` - ftp client
    `theCMD` - command to execute
  Throws:
    `java.io.IOException` - in unknown circumstances
    `BuildException` - in unknown circumstances

### sendFile

    protected void sendFile(org.apache.commons.net.ftp.FTPClient ftp,
                            java.lang.String dir,
                            java.lang.String filename)
                     throws java.io.IOException,
                            BuildException

  Sends a single file to the remote host. `filename` may contain a relative path specification. When this is the case, `sendFile` will attempt to create any necessary parent directories before sending the file. The file will then be sent using the entire relative path spec - no attempt is made to change directories. It is anticipated that this may eventually cause problems with some FTP servers, but it simplifies the coding.

  Parameters:
    `ftp` - ftp client
    `dir` - base directory of the file to be sent (local)
    `filename` - relative path of the file to be send locally relative to dir remotely relative to the remotedir attribute
  Throws:
    `java.io.IOException` - in unknown circumstances
    `BuildException` - in unknown circumstances

### delFile

    protected void delFile(org.apache.commons.net.ftp.FTPClient ftp,
                           java.lang.String filename)
                    throws java.io.IOException,
                           BuildException

  Delete a file from the remote host.

  Parameters:
    `ftp` - ftp client
    `filename` - file to delete
  Throws:
    `java.io.IOException` - in unknown circumstances
    `BuildException` - if skipFailedTransfers is set to false and the deletion could not be done

### rmDir

    protected void rmDir(org.apache.commons.net.ftp.FTPClient ftp,
                         java.lang.String dirname)
                  throws java.io.IOException,
                         BuildException

  Delete a directory, if empty, from the remote host.

  Parameters:
    `ftp` - ftp client
    `dirname` - directory to delete
  Throws:
    `java.io.IOException` - in unknown circumstances
    `BuildException` - if skipFailedTransfers is set to false and the deletion could not be done

### getFile

    protected void getFile(org.apache.commons.net.ftp.FTPClient ftp,
                           java.lang.String dir,
                           java.lang.String filename)
                    throws java.io.IOException,
                           BuildException

  Retrieve a single file from the remote host. `filename` may contain a relative path specification.

  The file will then be retreived using the entire relative path spec - no attempt is made to change directories. It is anticipated that this may eventually cause problems with some FTP servers, but it simplifies the coding.

  Parameters:
    `ftp` - the ftp client
    `dir` - local base directory to which the file should go back
    `filename` - relative path of the file based upon the ftp remote directory and/or the local base directory (dir)
  Throws:
    `java.io.IOException` - in unknown circumstances
    `BuildException` - if skipFailedTransfers is false and the file cannot be retrieved.

### listFile

    protected void listFile(org.apache.commons.net.ftp.FTPClient ftp,
                            java.io.BufferedWriter bw,
                            java.lang.String filename)
                     throws java.io.IOException,
                            BuildException

  List information about a single file from the remote host. `filename` may contain a relative path specification.

  The file listing will then be retrieved using the entire relative path spec - no attempt is made to change directories. It is anticipated that this may eventually cause problems with some FTP servers, but it simplifies the coding.

  Parameters:
    `ftp` - ftp client
    `bw` - buffered writer
    `filename` - the directory one wants to list
  Throws:
    `java.io.IOException` - in unknown circumstances
    `BuildException` - in unknown circumstances

### makeRemoteDir

    protected void makeRemoteDir(org.apache.commons.net.ftp.FTPClient ftp,
                                 java.lang.String dir)
                          throws java.io.IOException,
                                 BuildException

  Create the specified directory on the remote host.

  Parameters:
    `ftp` - The FTP client connection
    `dir` - The directory to create (format must be correct for host type)
  Throws:
    `java.io.IOException` - in unknown circumstances
    `BuildException` - if ignoreNoncriticalErrors has not been set to true and a directory could not be created, for instance because it was already existing. Precisely, the codes 521, 550 and 553 will trigger a BuildException

### doFTP

    public void doFTP()
               throws BuildException

  Specified by:
    `doFTP` in interface `FTPTaskMirror`
  Throws:
    `BuildException`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD